package de.renew.formalism.fs;

import de.renew.engine.searchqueue.SearchQueue;

import de.renew.net.Net;
import de.renew.net.NetInstanceImpl;
import de.renew.net.NetNotFoundException;
import de.renew.net.Place;
import de.renew.net.PlaceInstance;

import de.renew.unify.Impossible;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;


public class ObjectNetInstance extends NetInstanceImpl {
    protected ObjectNetInstance(String netName, Hashtable marking)
            throws Impossible, NetNotFoundException {
        this(Net.forName(netName), marking);
    }

    protected ObjectNetInstance(Net net, Hashtable marking)
            throws Impossible {
        super(net);

        // Build hashtable of place names.
        Hashtable nameToPlace = new Hashtable();
        synchronized (net) {
            Iterator iterator = net.places().iterator();
            while (iterator.hasNext()) {
                Place place = (Place) iterator.next();
                nameToPlace.put(place.toString(), place);
            }
        }


        // Transfer tokens.
        Enumeration enumeration = marking.keys();
        while (enumeration.hasMoreElements()) {
            String name = (String) enumeration.nextElement();
            PlaceInstance instance = getInstance((Place) nameToPlace.get(name));

            Enumeration tokens = ((Vector) marking.get(name)).elements();
            while (tokens.hasMoreElements()) {
                // This used to be done silently. As there should be no 
                // listeners yet, it can be done openly just as well.
                instance.insertToken(tokens.nextElement(), SearchQueue.getTime());
            }
        }
    }
}