/*
 * @author Timo Carl
 * Created: 06.05.2004
 *
 */
package de.renew.plugin;



/**
 * Callback interface for events that are generated by the Pluginmanager.
*/
public interface IPluginManagerListener {

    /**
     * function is called when a new service has been added to Renew.
     * @param service identifier of the Service
     */
    public void serviceAdded(String service);

    /**
     * function is called when a service has been removed from Renew.
     * @param service identifier of the Service
     */
    public void serviceRemoved(String service);
}