package de.renew.engine.common;

import de.renew.engine.searcher.AbstractOccurrence;
import de.renew.engine.searcher.OccurrenceDescription;
import de.renew.engine.searcher.Searcher;
import de.renew.engine.searcher.VariableMapperCopier;

import de.renew.expression.Expression;
import de.renew.expression.VariableMapper;

import de.renew.net.TransitionInstance;

import de.renew.unify.Impossible;

import java.util.Collection;
import java.util.Collections;


public class ActionOccurrence extends AbstractOccurrence {
    Expression expression;
    VariableMapper mapper;

    public ActionOccurrence(Expression expression, VariableMapper mapper,
                            TransitionInstance tInstance) {
        super(tInstance);
        this.expression = expression;
        this.mapper = mapper;
    }

    public Collection makeBinders(Searcher searcher) throws Impossible {
        expression.registerCalculation(mapper, searcher.recorder,
                                       searcher.calcChecker);
        // That's it. No binders required.
        return Collections.EMPTY_SET;
    }

    public Collection makeExecutables(VariableMapperCopier copier) {
        return Collections.singleton(new ActionExecutable(expression,
                                                          copier.makeCopy(mapper)));
    }

    public OccurrenceDescription makeOccurrenceDescription(VariableMapperCopier variableMapperCopier) {
        return null;
    }
}