package de.renew.engine.common;

import de.renew.expression.Expression;
import de.renew.expression.VariableMapper;

import de.renew.net.TransitionInstance;

import de.renew.unify.Unify;

import java.util.Collection;
import java.util.Collections;


public class SimpleEnumeratorOccurrence extends EnumeratorOccurrence {
    private Collection collection;

    public SimpleEnumeratorOccurrence(Expression expression,
                                      boolean checkBound,
                                      VariableMapper mapper,
                                      Collection collection,
                                      TransitionInstance tInstance) {
        super(expression, checkBound, mapper, tInstance);
        this.collection = collection;
    }

    public Collection getCandidates(Object pattern) {
        if (Unify.isBound(pattern)) {
            if (collection.contains(pattern)) {
                return Collections.singleton(pattern);
            } else {
                return Collections.EMPTY_SET;
            }
        } else {
            return collection;
        }
    }
}