package de.renew.net;

import de.renew.engine.common.StepIdentifier;
import de.renew.engine.searcher.LateExecutable;

import de.renew.net.event.FiringEvent;


public class FiringStartExecutable implements LateExecutable {
    private FiringEvent event;

    FiringStartExecutable(FiringEvent event) {
        this.event = event;
    }

    public int phase() {
        return START;
    }

    public boolean isLong() {
        return false;
    }

    public void execute(StepIdentifier stepIdentifier) {
        event.getTransitionInstance().firingStarted(event);
    }

    public void executeAfterException(StepIdentifier stepIdentifier, Throwable t) {
        // This should not happen, but ignore the exception.
        execute(stepIdentifier);
    }
}