package de.renew.net.inscription;

import de.renew.engine.searcher.Searcher;

import de.renew.expression.Expression;
import de.renew.expression.VariableMapper;

import de.renew.net.NetInstance;
import de.renew.net.Transition;
import de.renew.net.TransitionInscription;

import java.util.Collections;


public class ConditionalInscription implements TransitionInscription {
    Expression conditionExpression;
    TransitionInscription inscription;
    Transition transition;

    public ConditionalInscription(Expression conditionExpression,
                                  TransitionInscription inscription,
                                  Transition transition) {
        this.conditionExpression = conditionExpression;
        this.inscription = inscription;
        this.transition = transition;
    }

    public java.util.Collection makeOccurrences(VariableMapper mapper,
                                                NetInstance netInstance,
                                                Searcher searcher) {
        return Collections.singleton(new ConditionalOccurrence(this, mapper,
                                                               netInstance,
                                                               this.transition));
    }
}