package de.renew.net.inscription;

import de.renew.engine.searcher.Searcher;

import de.renew.expression.LocalVariable;
import de.renew.expression.VariableMapper;

import de.renew.net.Net;
import de.renew.net.NetInstance;
import de.renew.net.Transition;
import de.renew.net.TransitionInscription;

import java.util.Collections;


public class CreationInscription implements TransitionInscription {
    private Net net;
    private LocalVariable createVariable;
    private Transition transition;

    public CreationInscription(Net net, LocalVariable createVariable,
                               Transition transition) {
        this.net = net;
        this.createVariable = createVariable;
        this.transition = transition;
    }

    public java.util.Collection makeOccurrences(VariableMapper mapper,
                                                NetInstance netInstance,
                                                Searcher searcher) {
        return Collections.singleton(new CreationOccurrence(mapper.map(createVariable),
                                                            net,
                                                            netInstance
                                                            .getInstance(transition)));
    }
}